.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\include\fpu.inc
includelib \masm32\lib\fpu.lib

.listall
inv equ Invoke

; procs to test
Procs textequ <qSortdx,MergeSort,RadixSort3>
Tests textequ <Random,Sorted,Reversed,Constant,Alternating,Cyclic,Tapering>

;PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <HIGH_PRIORITY_CLASS>
PriClass textequ <NORMAL_PRIORITY_CLASS>   ; for debugging

times = 3   ; Number of times to run each test. Fastest time is used.

.data
randsize dd 2000000  ;1048575 ; number of items to sort
.code

%FOR proc,<setup,IdCPU,Procs>
    align 16
    %include @CatStr(<proc>,<.asm>)
ENDM
Align 16
Program:
    pusha
    call IdentifyCPU
    add ccx,4
    loc ccy,ccx
    print chr$("Sort Timing tests, sorting ")
    print ustr$(randsize)
    print chr$(" integers")
    add ccx,2
    loc ccy,ccx
    print chr$("Input data    Routine      Cycles   Millisec")
    add ccx,2
    BeginCounter    ; compute overhead
    EndCounter

%For tst,<Tests>
  arg2 catstr <">,<tst>,<">
  inv locate,ccy,ccx
  %print chr$(" ",arg2,":")
  arg1 catstr <Gen>,<tst>
  call arg1  ; go generate data
    
  pcnt=0
  %FOR prc,<Procs>
    pcnt=pcnt+1
    mov tempans,-1
    arg2 catstr <">,<prc>,<">
    mov ccy,15
    inv locate,ccy,ccx
    %print chr$(arg2)
    repeat times
        call copyandclean
        BeginCounter
            invoke  prc, rheap,randsize
        EndCounter
        call CheckAnswer
        mov eax,counts
        .if eax<tempans
            mov tempans,eax
        .endif
    endm
    mov eax,tempans
    mov counts,eax
    call GetAnswers
    if pcnt eq 1
        mov eax,counts
        mov basecount,eax
    endif
    if pcnt ge 2
      call compprcnt
    endif
    invoke  Sleep, 250
  endm
  add ccx,1
endm
    inv locate,ccy,ccx
    mov eax, input(" Press ENTER to exit...")

    popa
	Invoke ExitProcess, 0

End	Program
