.data
;randsize dd 1048576-1 ;16;1048576-1+4 ;1000000  ; 1048576 ;
randseed dd 012345678
gheap dd 0  ; the generated values to be sorted 
rheap dd 0  ; pointer to values to be sorted
aheap dd 0  ; pointer to answers
xheap dd 0  ; the location of the scratch heap for everyone to use equally.
tmpsize dd 0
t100  dd 100
.data?
hHeap dd ?  ; the handle to the main heap
iheap dd ?  ; the values passed to the routine under test
basecount dd ?
buff db 20 dup (?)
tmp  dd ?
tmp2 dd ?
tmp3 dd ?
.code

copyandclean:
    pusha
    mov esi,gheap
    mov edi,rheap
    mov ecx,randsize
    rep movsd      ; copy values to test

    mov eax,-1     ; wipe out any previous scratch
    mov ecx,randsize
    mov edi,xheap
    rep stosd
    popa
    ret
    
GetHeap:
    .if rheap==0
        inv GetProcessHeap
        mov hHeap,eax
        mov eax,randsize
        add eax,4
        and eax,not 3   ; get even 4 words to make tests consistant
        shl eax,2       ; dwords to bytes
        mov tmpsize,eax
        shl eax,2       ; * 4 for four buffers
        inv HeapAlloc,hHeap,HEAP_ZERO_MEMORY    ,eax
        mov gheap,eax    ; the generated values to sort
        add eax,tmpsize    
        mov aheap,eax    ; the values sorted 
        add eax,tmpsize
        mov rheap,eax    ; the values passed to routine for sorting 
        add eax,tmpsize
        mov xheap,eax    ; the scratch heap
    .endif
    ret
GenRandom:
    pusha
    call GetHeap
    inv nseed,randseed
    mov esi,randsize
    mov edi,gheap
    .repeat
        inv nrandom,80000000h-1
        .if eax>40000000h
            neg eax
        .endif
        mov [edi],eax
        add edi,4
        dec esi
    .until zero?
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    inv nrQsortA,aheap,randsize ; get answer from masmlib
    popa
    ret
GenSorted:
    pusha
    call GetHeap
    mov esi,0
    mov edi,gheap
    mov eax,randsize
    shr eax,1
    neg eax     ; from -randsize/2 to randsize/2
    .repeat
        mov [edi+esi*4],eax
        inc eax
        inc esi
    .until esi==randsize
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    popa
    ret
GenReversed:
    pusha
    call GetHeap
    mov esi,0
    mov edi,gheap
    mov eax,randsize
    ;;shr eax,1   ; from randsize/2 to -randsize/2  ******************************************fix *****
    .repeat
        mov [edi+esi*4],eax
        dec eax
        inc esi
    .until esi==randsize
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    inv nrQsortA,aheap,randsize ; get answer from masmlib
    popa
    ret
GenConstant:
    pusha
    call GetHeap
    mov esi,0
    mov edi,gheap
    mov eax,9999
    .repeat
        mov [edi+esi*4],eax
        inc esi
    .until esi==randsize
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    popa
    ret

GenAlternating:
    pusha
    call GetHeap
    mov esi,0
    mov edi,gheap
    mov eax,randsize
    ;shr eax,1
    mov ecx,1
    ;neg eax        ; from -randsize/2 to randsize/2
    .repeat
        mov [edi+esi*4],eax
        inc esi
        ;neg eax     ; alternate high and low values
        ;mov [edi+esi*4],eax
        mov [edi+esi*4],ecx
        ;neg eax     ; restore for next store
        dec eax
        inc ecx
        inc esi
    .until esi>=randsize    ; don't use an odd number of values
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    inv nrQsortA,aheap,randsize ; get answer from masmlib
    popa    
    ret
GenCyclic:
.data
  cycamt dd 1
.code
    pusha
    call GetHeap
    mov esi,0
    mov edi,gheap
    mov eax,1
    .repeat
        mov [edi+esi*4],eax
        inc eax
        .if eax==cycamt ;17 ; generate 0-17 repeatedly
            mov eax,0
        .endif
        inc esi
    .until esi==randsize
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    inv nrQsortA,aheap,randsize ; get answer from masmlib
    popa
    ret
GenTapering:
    pusha
    call GetHeap
    mov esi,0
    mov edi,gheap
    mov eax,randsize    ; will count down from both ends toward middle
    mov ecx,randsize    ; e.g. 10 8 6 4 2 0 1 3 5 7 9
    sub ecx,1
    mov edx,randsize
    ;shr edx,1          ; half
    .repeat
        mov [edi+esi*4],eax
        dec eax
        mov [edi+ecx*4],eax
        dec eax
        inc esi
        dec ecx
        sub edx,2   ; count
    .until sign?
    mov esi,gheap
    mov edi,aheap
    mov ecx,randsize
    rep movsd       ; copy to answers
    inv CombSortA,aheap,randsize    ; get answer from masmlib. Quicksort no good for this.
    ;call ShowRan
    popa
    ret
        
.data
fmt db 'error at index %li found %li should be %li',0
.data?
obuf dd 100 dup(?)
.code 
CheckAnswer proc

    pusha
    mov eax,randsize
    .if eax<2
        jmp cawrap
    .endif
    mov esi,rheap
    mov edi,aheap
    mov ecx,0
    mov edx,5
    .repeat
        mov eax,[esi+ecx*4]
        mov edx,[edi+ecx*4]
        .if sdword ptr eax!=edx
            pusha
            mov ebx,eax
            inv wsprintf,addr obuf,addr fmt,ecx,ebx,edx
            inv MessageBox,0,addr obuf,0,MB_OKCANCEL
            .if eax==IDCANCEL
                popa
                jmp cawrap
            .endif
            popa
            dec edx
            jz cawrap
        .endif
        inc ecx
    .until ecx==randsize
cawrap:
    popa
    ret
CheckAnswer endp
.data
fmt2 db '%li%',0
.code
ShowRan:
    pusha
    mov esi,rheap
    mov edi,0
    .repeat
        lodsd
        pusha
        inv wsprintf,addr obuf,addr fmt2,eax
        inv MessageBox,0,addr obuf,0,MB_OKCANCEL
            .if eax==IDCANCEL
                popa
                jmp srwrap
            .endif
            popa
        inc edi
    .until edi==randsize
srwrap:
    popa
    ret

.data
DoingOverhead dd 1	; very first pass will be overhead pass
overhead real8 0.0	; overhead of doing an empty test
pcfreq  dq 0
precnt  dq 0
pccount dq 0
counts  dd 0
pcanswr dq 0
t1000   dq 1000
pcreal  real8 0.0
prival  dd PriClass
tempans dd 0
ccx     dd 1    ; screen location
ccy     dd 1
.code


compprcnt:
    pusha
    mov eax,basecount
    mov edi,eax ; save
    mov eax,counts
    sub eax,edi
    mov tmp,eax ; save answer
    mov tmp3,edi
    fild tmp
    fild tmp3
    fdiv
    fild t100
    fmul
    inv FpuFLtoA,0,2,addr buff,SRC1_FPU or SRC2_DIMM
    mov edi,offset buff
    mov ecx,100
    xor eax,eax
    repne scasb
    mov eax,'%'
    mov [edi-1],eax
    sub ccx,1
    mov ccy,46
    invoke locate,ccy,ccx
    lea edi,buff
    print edi
    add ccx,1
    mov ccy,1
    popa
    ret

; the timing routines
BeginCounter macro  ; This macro is inserted before a block of test code
    align 16    ; just to be sure all code starts with equal advantage
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, prival  ; use the highest priority for all the tests
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_TIME_CRITICAL
    Repeat 6    ; Intel says 4 but I've found that more works a little better
    xor eax,eax
    cpuid       ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
	inv QueryPerformanceCounter,addr precnt
endm
EndCounter macro        ; This macro is inserted after each block of test code
    xor eax,eax
    cpuid       ; flush
    inv QueryPerformanceCounter,addr pccount
    inv QueryPerformanceFrequency, ADDR pcfreq
    finit
    fild pccount
    fild precnt
    fsub
	fwait
	.if DoingOverhead
		fst overhead
    	mov DoingOverhead,0
	.endif
	fsub overhead
	fist counts
    invoke GetCurrentThread
    inv SetThreadPriority,eax,THREAD_PRIORITY_NORMAL
    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS ; back to normal
    inv Sleep,0 
	
endm

GetAnswers proc
    pusha
	mov ccy,29
	inv locate,ccy,ccx
	mov edi,counts
	.if edi < 100000
	   print chr$(" ")
	.endif
	print ustr$(edi)
	mov ccy,37
    fild counts
    fild pcfreq
    fdiv
    fild t1000
    fmul
    fst pcreal
    fistp pcanswr
	fld pcreal
    inv FpuFLtoA,0,(4 shl 8) + 1,addr buff,SRC1_FPU or SRC2_DIMM
    inv locate,ccy,ccx
    lea eax,buff
    print eax
    add ccx,1
    mov ccy,1
    popa
	ret
GetAnswers endp